﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;

namespace OnDemandManualDemo
{
    public partial class MainPage : PhoneApplicationPage
    {
        private ObservableCollection<string> dataSource;
        private int pageStartIndex = 0;
        private int pageSize = 20;
        // Constructor
        public MainPage()
        {
            InitializeComponent();
            this.LoadData();
            this.LoadPage(this.pageStartIndex);
        }

        private void LoadPage(int page)
        {
            List<string> source = new List<string>();
            int endIndex = page + this.pageSize;
            for (int i = page; i < endIndex; i++)
            {
                source.Add(this.dataSource[i]);
            }

            if (endIndex == 200)
            {
                this.listBox.DataVirtualizationItemTemplate = this.LayoutRoot.Resources["DataVirtualizationTemplatePrev"] as DataTemplate;
            }
            else if (this.pageStartIndex == 0)
            {
                this.listBox.DataVirtualizationItemTemplate = this.LayoutRoot.Resources["DataVirtualizationTemplateNext"] as DataTemplate;
            }
            else
            {
                this.listBox.DataVirtualizationItemTemplate = this.LayoutRoot.Resources["DataVirtualizationTemplateNextPrev"] as DataTemplate;
            }

            this.listBox.ItemsSource = source;
        }

        private void LoadData()
        {
            this.dataSource = new ObservableCollection<string>();

            for (int i = 0; i < 200; i++)
            {
                this.dataSource.Add("Item " + i);
            }
        }

        private void btnPrev_Click(object sender, RoutedEventArgs e)
        {
            ((sender as Button)).IsEnabled = true;
            this.pageStartIndex -= this.pageSize;
            this.LoadPage(this.pageStartIndex);
        }

        private void btnNext_Click(object sender, RoutedEventArgs e)
        {
            ((sender as Button)).IsEnabled = true;
            this.pageStartIndex += this.pageSize;
            this.LoadPage(this.pageStartIndex);
        }
    }
}